#! /usr/bin/env python3

''' Classic, Big Character Printer '''


glyph_dict = \
{' ': ['        ',
       '        ',
       '        ',
       '        ',
       '        ',
       '        ',
       '        ',
       '        ',
       '        '],
 '!': ['  XX    ',
       '  XX    ',
       '  XX    ',
       '  XX    ',
       '  XX    ',
       '        ',
       '  XX    ',
       '        ',
       '        '],
 '#': [' XX XX  ',
       ' XX XX  ',
       'XXXXXXX ',
       ' XX XX  ',
       'XXXXXXX ',
       ' XX XX  ',
       ' XX XX  ',
       '        ',
       '        '],
 '$': ['   XX   ',
       ' XXXXXX ',
       ' X      ',
       ' XXXXXX ',
       '      X ',
       ' XXXXXX ',
       '   XX   ',
       '        ',
       '        '],
 '%': ['XX    X ',
       'XX   XX ',
       '    XX  ',
       '   XX   ',
       '  XX    ',
       ' XX  XX ',
       'XX   XX ',
       '        ',
       '        '],
 '&': ['  XXX   ',
       '  X X   ',
       '  XXX   ',
       ' XXXX XX',
       'XX X XX ',
       'XX  XX  ',
       ' XXX XXX',
       '        ',
       '        '],
 '(': ['   XXX  ',
       ' XXX    ',
       'XX      ',
       'XX      ',
       'XX      ',
       ' XXX    ',
       '   XXX  ',
       '        ',
       '        '],
 ')': [' XXX    ',
       '   XXX  ',
       '     XX ',
       '     XX ',
       '     XX ',
       '   XXX  ',
       ' XXX    ',
       '        ',
       '        '],
 '*': ['        ',
       ' XX XX  ',
       '  XXX   ',
       'XXXXXXX ',
       '  XXX   ',
       ' XX XX  ',
       '        ',
       '        ',
       '        '],
 '+': ['  XX    ',
       '  XX    ',
       '  XX    ',
       'XXXXXX  ',
       '  XX    ',
       '  XX    ',
       '  XX    ',
       '        ',
       '        '],
 ',': ['        ',
       '        ',
       '        ',
       '        ',
       '        ',
       ' XX     ',
       '  X     ',
       ' X      ',
       '        '],
 '-': ['        ',
       '        ',
       '        ',
       '  XXXXX ',
       '        ',
       '        ',
       '        ',
       '        ',
       '        '],
 '.': ['        ',
       '        ',
       '        ',
       '        ',
       '        ',
       '     XX ',
       '     XX ',
       '        ',
       '        '],
 '/': ['      X ',
       '     XX ',
       '    XX  ',
       '   XX   ',
       '  XX    ',
       ' XX     ',
       'XX      ',
       '        ',
       '        '],
 '0': [' XXXXX  ',
       'XX   XX ',
       'XX  XXX ',
       'XX X XX ',
       'XXX  XX ',
       'XX   XX ',
       ' XXXXX  ',
       '        ',
       '        '],
 '1': ['   X    ',
       ' XXX    ',
       '  XX    ',
       '  XX    ',
       '  XX    ',
       '  XX    ',
       ' XXXX   ',
       '        ',
       '        '],
 '2': [' XXXX   ',
       'XX  XX  ',
       '    XX  ',
       '   XX   ',
       '  XX    ',
       ' XX   X ',
       'XXXXXXX ',
       '        ',
       '        '],
 '3': [' XXXX   ',
       'XX  XX  ',
       '    XX  ',
       '  XXX   ',
       '    XX  ',
       'XX  XX  ',
       ' XXXX   ',
       '        ',
       '        '],
 '4': ['    XX  ',
       '   XXX  ',
       ' XX XX  ',
       'XX  XX  ',
       'XXXXXXX ',
       '    XX  ',
       '   XXXX ',
       '        ',
       '        '],
 '5': [' XXXXXX ',
       ' X      ',
       ' X      ',
       ' XXXXX  ',
       '     XX ',
       'XX   XX ',
       ' XXXXX  ',
       '        ',
       '        '],
 '6': ['  XXXX  ',
       ' XX  X  ',
       'XX      ',
       'XXXXXX  ',
       'XX   XX ',
       'XX   XX ',
       ' XXXXX  ',
       '        ',
       '        '],
 '7': ['XXXXXXX ',
       'X    XX ',
       '    XX  ',
       '   XX   ',
       '   XX   ',
       '   XX   ',
       '   XX   ',
       '        ',
       '        '],
 '8': ['  XXXX  ',
       ' XX  XX ',
       ' XX  XX ',
       '  XXXX  ',
       ' XX  XX ',
       ' XX  XX ',
       '  XXXX  ',
       '        ',
       '        '],
 '9': [' XXXXX  ',
       'XX   XX ',
       'XX   XX ',
       ' XXXXXX ',
       '     XX ',
       ' X  XX  ',
       ' XXXX   ',
       '        ',
       '        '],
 '<': ['   XX   ',
       '  XX    ',
       ' XX     ',
       'XX      ',
       ' XX     ',
       '  XX    ',
       '   XX   ',
       '        ',
       '        '],
 '=': ['        ',
       '        ',
       ' XXXXX  ',
       '        ',
       ' XXXXX  ',
       '        ',
       '        ',
       '        ',
       '        '],
 '>': ['XX      ',
       ' XX     ',
       '  XX    ',
       '   XX   ',
       '  XX    ',
       ' XX     ',
       'XX      ',
       '        ',
       '        '],
 '?': [' XXXX   ',
       'XX  XX  ',
       'X   XX  ',
       '   XXX  ',
       '  XX    ',
       '        ',
       '  XX    ',
       '        ',
       '        '],
 '@': ['  XXXX  ',
       ' X   XX ',
       'XX    X ',
       'XX  XXX ',
       'XX  XX  ',
       ' X      ',
       ' XXXX   ',
       '        ',
       '        '],
 'A': ['   XX   ',
       '  XXXX  ',
       ' XX  XX ',
       ' XX  XX ',
       ' XXXXXX ',
       ' XX  XX ',
       ' XX  XX ',
       '        ',
       '        '],
 'B': ['XXXXXX  ',
       ' XX  XX ',
       ' XX  XX ',
       ' XXXXX  ',
       ' XX  XX ',
       ' XX  XX ',
       'XXXXXX  ',
       '        ',
       '        '],
 'C': ['  XXXX  ',
       ' XX  XX ',
       'XX      ',
       'XX      ',
       'XX    X ',
       ' XX  XX ',
       '  XXXX  ',
       '        ',
       '        '],
 'D': ['XXXXXX  ',
       ' XX  XX ',
       ' XX  XX ',
       ' XX  XX ',
       ' XX  XX ',
       ' XX  XX ',
       'XXXXXX  ',
       '        ',
       '        '],
 'E': ['XXXXXXX ',
       ' XX   X ',
       ' XX X   ',
       ' XXXX   ',
       ' XX X   ',
       ' XX   X ',
       'XXXXXXX ',
       '        ',
       '        '],
 'F': ['XXXXXXX ',
       ' XX   X ',
       ' XX X   ',
       ' XXXX   ',
       ' XX X   ',
       ' XX     ',
       'XXXX    ',
       '        ',
       '        '],
 'G': ['  XXXX  ',
       ' XX  X  ',
       'XX      ',
       'XX      ',
       'XX  XXX ',
       ' XX  XX ',
       '  XXX X ',
       '        ',
       '        '],
 'H': ['XX  XX  ',
       'XX  XX  ',
       'XX  XX  ',
       'XXXXXX  ',
       'XX  XX  ',
       'XX  XX  ',
       'XX  XX  ',
       '        ',
       '        '],
 'I': ['  XXXX  ',
       '   XX   ',
       '   XX   ',
       '   XX   ',
       '   XX   ',
       '   XX   ',
       '  XXXX  ',
       '        ',
       '        '],
 'J': ['  XXXX  ',
       '   XX   ',
       '   XX   ',
       '   XX   ',
       'X  XX   ',
       'XX XX   ',
       ' XXX    ',
       '        ',
       '        '],
 'K': ['XXX  XX ',
       ' XX  XX ',
       ' XX XX  ',
       ' XXXX   ',
       ' XX XX  ',
       ' XX  XX ',
       'XXX  XX ',
       '        ',
       '        '],
 'L': ['XXXX    ',
       ' XX     ',
       ' XX     ',
       ' XX     ',
       ' XX     ',
       ' XX  XX ',
       'XXXXXXX ',
       '        ',
       '        '],
 'M': ['XX   XX ',
       'XXX XXX ',
       'XXXXXXX ',
       'XX X XX ',
       'XX   XX ',
       'XX   XX ',
       'XX   XX ',
       '        ',
       '        '],
 'N': ['XX   XX ',
       'XXX  XX ',
       'XXXX XX ',
       'XX XXXX ',
       'XX  XXX ',
       'XX   XX ',
       'XX   XX ',
       '        ',
       '        '],
 'O': [' XXXXX  ',
       'XX   XX ',
       'XX   XX ',
       'XX   XX ',
       'XX   XX ',
       'XX   XX ',
       ' XXXXX  ',
       '        ',
       '        '],
 'P': ['XXXXXX  ',
       ' XX  XX ',
       ' XX  XX ',
       ' XXXXX  ',
       ' XX     ',
       ' XX     ',
       'XXXX    ',
       '        ',
       '        '],
 'Q': [' XXXXX  ',
       'XX   XX ',
       'XX   XX ',
       'XX   XX ',
       'XX   XX ',
       'XX   XX ',
       ' XXXXX  ',
       '     XX ',
       '        '],
 'R': ['XXXXXX  ',
       ' XX  XX ',
       ' XX  XX ',
       ' XXXXX  ',
       ' XX XX  ',
       ' XX  XX ',
       'XXX  XX ',
       '        ',
       '        '],
 'S': [' XXXXXX ',
       'XX    X ',
       'XX      ',
       ' XXXXX  ',
       '     XX ',
       'X    XX ',
       'XXXXXX  ',
       '        ',
       '        '],
 'T': [' XXXXXX ',
       ' X XX X ',
       '   XX   ',
       '   XX   ',
       '   XX   ',
       '   XX   ',
       '  XXXX  ',
       '        ',
       '        '],
 'U': [' XX  XX ',
       ' XX  XX ',
       ' XX  XX ',
       ' XX  XX ',
       ' XX  XX ',
       ' XX  XX ',
       '  XXXX  ',
       '        ',
       '        '],
 'V': ['XX   XX ',
       'XX   XX ',
       'XX   XX ',
       ' XX XX  ',
       ' XX XX  ',
       '  XXX   ',
       '   X    ',
       '        ',
       '        '],
 'W': ['XX   XX ',
       'XX   XX ',
       'XX   XX ',
       'XX X XX ',
       'XXXXXXX ',
       'XXX XXX ',
       'XX   XX ',
       '        ',
       '        '],
 'X': ['XXX XXX ',
       ' XX XX  ',
       '  XXX   ',
       '   X    ',
       '  XXX   ',
       ' XX XX  ',
       'XXX XXX ',
       '        ',
       '        '],
 'Y': ['XX    XX',
       ' XX  XX ',
       '  XXXX  ',
       '   XX   ',
       '   XX   ',
       '   XX   ',
       '  XXXX  ',
       '        ',
       '        '],
 'Z': ['XXXXXXX ',
       'X    XX ',
       '    XX  ',
       '   XX   ',
       '  XX    ',
       ' XX   X ',
       'XXXXXXX ',
       '        ',
       '        '],
 '[': [' XXXXX  ',
       ' XX     ',
       ' XX     ',
       ' XX     ',
       ' XX     ',
       ' XX     ',
       ' XXXXX  ',
       '        ',
       '        '],
 '\\': ['XX      ',
        ' XX     ',
        '  XX    ',
        '   XX   ',
        '    XX  ',
        '     XX ',
        '      X ',
        '        ',
        '        '],
 ']': ['  XXXXX ',
       '     XX ',
       '     XX ',
       '     XX ',
       '     XX ',
       '     XX ',
       '  XXXXX ',
       '        ',
       '        '],
 '^': ['   X    ',
       '  XXX   ',
       ' XX XX  ',
       'XX   XX ',
       '        ',
       '        ',
       '        ',
       '        ',
       '        '],
 '_': ['        ',
       '        ',
       '        ',
       '        ',
       '        ',
       '        ',
       ' XXXXX  ',
       '        ',
       '        '],
 '`': ['    XX  ',
       '    X   ',
       '     X  ',
       '        ',
       '        ',
       '        ',
       '        ',
       '        ',
       '        '],
 'a': ['        ',
       '        ',
       ' XXXXX  ',
       '     X  ',
       'XXXXXX  ',
       'X   XX  ',
       'XXXXX X ',
       '        ',
       '        '],
 'b': ['XXX     ',
       ' XX     ',
       ' XX     ',
       ' XXXXX  ',
       ' XX  XX ',
       ' XX  XX ',
       'XXXXXX  ',
       '        ',
       '        '],
 'c': ['        ',
       '        ',
       ' XXXXX  ',
       'XX   XX ',
       'XX      ',
       'XX   XX ',
       ' XXXXX  ',
       '        ',
       '        '],
 'd': ['   XXX  ',
       '    XX  ',
       '    XX  ',
       ' XXXXX  ',
       'XX  XX  ',
       'XX  XX  ',
       ' XXXX X ',
       '        ',
       '        '],
 'e': ['        ',
       '        ',
       ' XXXXX  ',
       'XX    X ',
       'XXXXXXX ',
       'XX      ',
       ' XXXXX  ',
       '        ',
       '        '],
 'f': ['  XXX   ',
       ' XX XX  ',
       ' XX     ',
       'XXXXX   ',
       ' XX     ',
       ' XX     ',
       'XXXX    ',
       '        ',
       '        '],
 'g': ['        ',
       '        ',
       ' XXXX XX',
       'XX   XX ',
       'XX   XX ',
       ' XXXXXX ',
       '     X  ',
       ' XXXXX  ',
       '        '],
 'h': ['XXX     ',
       ' XX     ',
       ' XX     ',
       ' XX XXX ',
       ' XXX XX ',
       ' XX  XX ',
       'XXX  XXX',
       '        ',
       '        '],
 'i': ['   XX   ',
       '        ',
       '  XXX   ',
       '   XX   ',
       '   XX   ',
       '   XX   ',
       '  XXXX  ',
       '        ',
       '        '],
 'j': ['   XX   ',
       '        ',
       '  XXXX  ',
       '   XX   ',
       '   XX   ',
       '   XX   ',
       'XX XX   ',
       ' XXX    ',
       '        '],
 'k': ['XXX     ',
       ' XX     ',
       ' XX  XX ',
       ' XX XX  ',
       ' XXX    ',
       ' XX XX  ',
       'XXX  XX ',
       '        ',
       '        '],
 'l': ['  XXX   ',
       '   XX   ',
       '   XX   ',
       '   XX   ',
       '   XX   ',
       '   XX   ',
       '  XXXX  ',
       '        ',
       '        '],
 'm': ['        ',
       '        ',
       'XXX XX  ',
       'XX X XX ',
       'XX X XX ',
       'XX   XX ',
       'XXX  XXX',
       '        ',
       '        '],
 'n': ['        ',
       '        ',
       ' XX XXX ',
       ' XXX XX ',
       ' XX  XX ',
       ' XX  XX ',
       ' XX  XX ',
       '        ',
       '        '],
 'o': ['        ',
       '        ',
       '  XXXX  ',
       ' XX  XX ',
       ' XX  XX ',
       ' XX  XX ',
       '  XXXX  ',
       '        ',
       '        '],
 'p': ['        ',
       '        ',
       'XX XXX  ',
       ' XX  XX ',
       ' XX  XX ',
       ' XXXXX  ',
       ' XX     ',
       'XXXX    ',
       '        '],
 'q': ['        ',
       '        ',
       ' XXX XX ',
       'XX  XX  ',
       'XX  XX  ',
       ' XXXXX  ',
       '    XX  ',
       '   XXXX ',
       '        '],
 'r': ['        ',
       '        ',
       'XX XXX  ',
       ' XXX XX ',
       ' XX     ',
       ' XX     ',
       'XXXX    ',
       '        ',
       '        '],
 's': ['        ',
       '        ',
       'XXXXXXX ',
       'XX      ',
       'XXXXXXX ',
       '     XX ',
       'XXXXXXX ',
       '        ',
       '        '],
 't': ['   X    ',
       '  XX    ',
       ' XXXXX  ',
       '  XX    ',
       '  XX    ',
       '  XX XX ',
       '   XXX  ',
       '        ',
       '        '],
 'u': ['        ',
       '        ',
       'XX  XXX ',
       'XX  XX  ',
       'XX  XX  ',
       'XX  XX  ',
       ' XXX XX ',
       '        ',
       '        '],
 'v': ['        ',
       '        ',
       ' XX  XX ',
       ' XX  XX ',
       ' XX  XX ',
       '  XXXX  ',
       '   XX   ',
       '        ',
       '        '],
 'w': ['        ',
       '        ',
       'XX   XX ',
       'XX X XX ',
       'XX X XX ',
       'XXXXXXX ',
       ' XX XX  ',
       '        ',
       '        '],
 'x': ['        ',
       '        ',
       'XX   XX ',
       ' XX XX  ',
       '  XXX   ',
       ' XX XX  ',
       'XX   XX ',
       '        ',
       '        '],
 'y': ['        ',
       '        ',
       'XX   XX ',
       'XX   XX ',
       'XX   XX ',
       ' XXXXXX ',
       '     X  ',
       ' XXXX   ',
       '        '],
 'z': ['        ',
       '        ',
       'XXXXXX  ',
       'X  XX   ',
       '  XX    ',
       ' XX  X  ',
       'XXXXXX  ',
       '        ',
       '        '],
 '{': ['    XX  ',
       '   XX   ',
       '   XX   ',
       '  XX    ',
       '   XX   ',
       '   XX   ',
       '    XX  ',
       '        ',
       '        '],
 '|': ['   X    ',
       '   X    ',
       '   X    ',
       '        ',
       '   X    ',
       '   X    ',
       '   X    ',
       '        ',
       '        '],
 '}': [' XX     ',
       '  XX    ',
       '  XX    ',
       '   XX   ',
       '  XX    ',
       '  XX    ',
       ' XX     ',
       '        ',
       '        '],
 '~': [' XX  XX ',
       'X  XX   ',
       '        ',
       '        ',
       '        ',
       '        ',
       '        ',
       '        ',
       '        ']}


def is_char(a_char) -> bool:
    ''' Return True if we can print the character '''
    return a_char in glyph_dict


def get_char(a_char)-> []:
    ''' Return the character, else an empty space '''
    if a_char in glyph_dict:
        return glyph_dict[a_char]
    return glyph_dict[' ']


def big_chars(message, space=0, a_char='*') -> str:
    ''' Create a printable big-message '''
    results = []
    for char in message:
        results.append(get_char(char))
    if not results:
        return None
    buffer = ''
    for high in range(len(results[0])):
        row = ''
        for xx in range(len(results)):
            row += results[xx][high]
            if space:
                spacer = ' ' * space # slo-what?
                row += spacer
        buffer += row + '\n'
    return buffer.replace('X', a_char)


def big_print(message, space=0, a_char='*'):
    ''' Print a big message to the standard output'''
    chars = big_chars(message, space, a_char)
    if chars:
        print(chars)
        return True
    return False


if __name__ == '__main__':
    if is_char(''):
        raise Exception("Empty string error.")
    if not get_char(''):
        raise Exception("Non-empty string error.")
    big_print('Soft9000', 0, '|')
    big_print('Nagy', 5, '#')

